dofile(minetest.get_modpath("qt_dimentions").."/functions.lua")
dofile(minetest.get_modpath("qt_dimentions").."/nodes.lua")
dofile(minetest.get_modpath("qt_dimentions").."/portals.lua")



    minetest.register_on_generated(function(minp, maxp, seed)
            local t1 = os.clock()
            local vm, emin, emax = minetest.get_mapgen_object("voxelmanip")
            local a = VoxelArea:new{
                    MinEdge={x=emin.x, y=emin.y, z=emin.z},
                    MaxEdge={x=emax.x, y=emax.y, z=emax.z},
            }

            local data = vm:get_data()
--river_water_source
            local c_dirt  = minetest.get_content_id("default:dirt")
            local c_grass = minetest.get_content_id("default:dirt_with_grass")
            local c_water = minetest.get_content_id("default:water_source")
			local c_lava = minetest.get_content_id("default:lava_source")
			local c_stone = minetest.get_content_id("default:stone")
			local c_air = minetest.get_content_id("air")
			local c_river_water = minetest.get_content_id("default:river_water_source")
			local c_obsidian = minetest.get_content_id("default:obsidian")

			local c_bedrock = minetest.get_content_id("qt:dimentional_seperator_203948")
			local c_hider = minetest.get_content_id("qt:dimentional_hider_043967097")

			local c_nether_stone = minetest.get_content_id("qt:nether_stone")
			local c_nether_sand = minetest.get_content_id("qt:nether_sand")
			local c_nether_stone_with_dark_diamond = minetest.get_content_id("qt:nether_stone_with_dark_diamond")

			local c_poison_stone = minetest.get_content_id("qt:poison_stone")
			local c_poison_dirt = minetest.get_content_id("qt:poison_dirt")
			local c_poison_grass = minetest.get_content_id("qt:poison_dirt_with_grass")
			local c_poison_liquid = minetest.get_content_id("qt:poison_liquid_source")
			local c_poison_stone_with_stratite = minetest.get_content_id("qt:poison_stone_with_stratite")

			local c_brilliance_stone = minetest.get_content_id("qt:brilliance_stone")
			local c_brilliance_dirt = minetest.get_content_id("qt:brilliance_dirt")
			local c_brilliance_dirt_with_grass = minetest.get_content_id("qt:brilliance_dirt_with_grass")
			local c_brilliance_sand = minetest.get_content_id("qt:brilliance_sand")
			local c_brilliance_sapling = minetest.get_content_id("qt:brilliance_sapling_instant")
			local c_brilliance_wildflower = minetest.get_content_id("qt:brilliance_wildflower")
			local c_brilliance_stone_with_lilimite = minetest.get_content_id("qt:brilliance_stone_with_lilimite")
			local c_brilliance_stone_with_cobalt = minetest.get_content_id("qt:brilliance_stone_with_cobalt")

			local c_murite_stone = minetest.get_content_id("qt:murite_stone")
			local c_murite_gravel = minetest.get_content_id("qt:murite_gravel")
			local c_murite_stone_with_crystal = minetest.get_content_id("qt:murite_stone_with_crystal")
			local c_mercury = minetest.get_content_id("qt:mercury_source")

			local c_etheral_stone = minetest.get_content_id("qt:etheral_stone")
			local c_etheral_dirt = minetest.get_content_id("qt:etheral_dirt")
			local c_etheral_dirt_with_grass = minetest.get_content_id("qt:etheral_dirt_with_grass")
			local c_etheral_sand = minetest.get_content_id("qt:etheral_sand")
			local c_etheral_sapling = minetest.get_content_id("qt:etheral_sapling_instant")
			local c_etheral_stone_with_corilium = minetest.get_content_id("qt:etheral_stone_with_corilium")
			local c_etheral_stone_with_carbite = minetest.get_content_id("qt:etheral_stone_with_carbite")
			local c_etheral_stone_with_steelium = minetest.get_content_id("qt:etheral_stone_with_steelium")
			local c_etheral_house_gen = minetest.get_content_id("qt:etheral_house_gen")
--etheral_stone_with_steelium
--etheral_house_gen

            local sidelen = maxp.x - minp.x + 1

            local nethernoise = minetest.get_perlin_map(
                    {offset=-12.3, scale=1, spread={x=200, y=50, z=200}, seed=50, octaves=5, persist=0.6},
                    {x=sidelen, y=sidelen, z=sidelen}
            )
            local nethernvals = nethernoise:get3dMap_flat({x=minp.x, y=minp.y, z=minp.z})


			local brilliancenoise = minetest.get_perlin_map(
                    {offset=18.5, scale=1, spread={x=200, y=40, z=200}, seed=40, octaves=3, persist=0.4},
                    {x=sidelen, y=sidelen, z=sidelen}
			)

			local brilliancenvals = brilliancenoise:get3dMap_flat({x=minp.x, y=minp.y, z=minp.z})

			local brilliancenoise_forest = minetest.get_perlin_map(
                    {offset=18.5, scale=1, spread={x=50, y=100000, z=50}, seed=40, octaves=3, persist=0.4},
                    {x=sidelen, y=sidelen, z=sidelen}
			)

			local brilliance_forestnvals = brilliancenoise_forest:get3dMap_flat({x=minp.x, y=minp.y, z=minp.z})

			local muritenoise = minetest.get_perlin_map(
                    {offset=-20, scale=1, spread={x=10, y=400, z=10}, seed=40, octaves=3, persist=0.4},
                    {x=sidelen, y=sidelen, z=sidelen}
			)

			local muritenvals = muritenoise:get3dMap_flat({x=minp.x, y=minp.y, z=minp.z})

			local etheralnoise = minetest.get_perlin_map(
                    {offset=36.3, scale=1, spread={x=10, y=10, z=10}, seed=60, octaves=1, persist=0.8},
                    {x=sidelen, y=sidelen, z=sidelen}
			)

			local etheralnvals = etheralnoise:get3dMap_flat({x=minp.x, y=minp.y, z=minp.z})

			local etheralnoise_forest = minetest.get_perlin_map(
                    {offset=36.3, scale=1, spread={x=50, y=100000, z=50}, seed=40, octaves=3, persist=0.4},
                    {x=sidelen, y=sidelen, z=sidelen}
			)

			local etheral_forestnvals = etheralnoise_forest:get3dMap_flat({x=minp.x, y=minp.y, z=minp.z})

            local ni = 1
            for z = minp.z, maxp.z do
            for y = minp.y, maxp.y do
            for x = minp.x, maxp.x do
					if y >= 489 and y <= 490 then
						local vi = a:index(x, y, z)
							data[vi] = c_hider
					end
					if y >= 491 and y <= 499 then
						local vi = a:index(x, y, z)
							data[vi] = c_bedrock
					end
					if y >= 500 and y <=1500 then
						local vi = a:index(x, y, z)
							data[vi] = c_air
							if brilliancenvals[ni] - (y - 25) / 55 > 0.5 then
									local vi = a:index(x, y, z)
									local va = a:index(x, y-1, z)
									local vb = a:index(x, y-2, z)
									local vc = a:index(x, y-3, z)
									if y > 1000 then
											data[vi] = c_brilliance_dirt_with_grass
											if data[va] == c_brilliance_dirt_with_grass then
											data[va] = c_brilliance_dirt
											end
											if data[vb] == c_brilliance_dirt then
											data[vb] = c_brilliance_dirt
											end
											if data[vc] == c_brilliance_dirt then
											data[vc] = c_brilliance_stone
											end
									else
											data[vi] = c_brilliance_sand
											if data[va] == c_brilliance_sand then
											data[va] = c_brilliance_sand
											end
											if data[vb] == c_brilliance_sand then
											data[vb] = c_brilliance_sand
											end
											if data[vc] == c_brilliance_sand then
											data[vc] = c_brilliance_stone
											end
									end
							elseif y < 1000 then
									local vi = a:index(x, y, z)
									data[vi] = c_river_water
							elseif brilliance_forestnvals[ni] - (y - 25) / 55 > 0.5 then
									--brilliance_forestnvals[ni] - (y - 25) / 55 > 0.5 then
									local vi = a:index(x, y, z)
									local va = a:index(x, y-1, z)
									if data[va] == c_brilliance_dirt_with_grass then
										local rnum = math.random(1, 60)
										if rnum == 1 then
											data[vi] = c_brilliance_sapling
										end
									end
							elseif y > 1000 then
									local vi = a:index(x, y, z)
									local va = a:index(x, y-1, z)
									if data[va] == c_brilliance_dirt_with_grass then
										local rnum = math.random(1, 50)
										if rnum == 1 then
											data[vi] = c_brilliance_wildflower
										end
									end
							end
							if y <= 1200 and y >= 500 then
								local rnum = math.random(1, 1500)
								if rnum == 1 then
									for b = -2, 2 do
									for c = -2, 2 do
									for d = -2, 2 do
										local vspot = a:index(x+b, y+c, z+d)
										local rnumb = math.random(1, 3)
										if rnumb == 1 and data[vspot] == c_brilliance_stone then
											data[vspot] = c_brilliance_stone_with_lilimite
										end
									end
									end
									end
								end
							end
							if y <= 800 and y >= 500 then
								local rnum = math.random(1, 2000)
								if rnum == 1 then
									for b = -2, 2 do
									for c = -2, 2 do
									for d = -2, 2 do
										local vspot = a:index(x+b, y+c, z+d)
										local rnumb = math.random(1, 3)
										if rnumb == 1 and data[vspot] == c_brilliance_stone then
											data[vspot] = c_brilliance_stone_with_cobalt
										end
									end
									end
									end
								end
							end
					end

					if y >= 1501 and y <= 1502 then
						local vi = a:index(x, y, z)
							data[vi] = c_hider
					end

					if y >= 1502 and y <= 1512 then
						local vi = a:index(x, y, z)
							data[vi] = c_bedrock
					end

					if y > 1512 and y <= 2750 then
						local vi = a:index(x, y, z)
						data[vi] = c_air
						if etheralnvals[ni] - (y - 25) / 55 > 0.5 then
							local vi = a:index(x, y, z)
							local va = a:index(x, y-1, z)
							local vb = a:index(x, y-2, z)
							local vc = a:index(x, y-3, z)
							if y >= 2001 then
								data[vi] = c_etheral_dirt_with_grass
								if data[va] == c_etheral_dirt_with_grass then
								data[va] = c_etheral_dirt
								end
								if data[vb] == c_etheral_dirt then
									data[vb] = c_etheral_dirt
								end
								if data[vc] == c_etheral_dirt then
									data[vc] = c_etheral_stone
								end
							else
								data[vi] = c_etheral_sand
								if data[va] == c_etheral_sand then
									data[va] = c_etheral_sand
								end
								if data[vb] == c_etheral_sand then
									data[vb] = c_etheral_sand
								end
								if data[vc] == c_etheral_sand then
									data[vc] = c_etheral_stone
								end
							end
						elseif y < 2000 then
							local vi = a:index(x, y, z)
							data[vi] = c_water
						elseif etheral_forestnvals[ni] - (y - 25) / 55 > 0.5 then
									--brilliance_forestnvals[ni] - (y - 25) / 55 > 0.5 then
									local vi = a:index(x, y, z)
									local va = a:index(x, y-1, z)
									if data[va] == c_etheral_dirt_with_grass then
										local rnum = math.random(1, 60)
										if rnum == 1 then
											data[vi] = c_etheral_sapling
										end
									end
						elseif y > 2000 then
									local vi = a:index(x, y, z)
									local va = a:index(x, y-1, z)
									if data[va] == c_etheral_dirt_with_grass then
										local rnum = math.random(1, 1000)
										if rnum == 1 then
											data[vi] = c_etheral_house_gen
										end
									end
						end
						if y <= 2020 and y >= 1512 then
							local rnum = math.random(1, 1500)
							if rnum == 1 then
								for b = -2, 2 do
								for c = -2, 2 do
								for d = -2, 2 do
									local vspot = a:index(x+b, y+c, z+d)
									local rnumb = math.random(1, 3)
									if rnumb == 1 and data[vspot] == c_etheral_stone then
										data[vspot] = c_etheral_stone_with_corilium
									end
								end
								end
								end
							end
						end
						if y <= 2020 and y >= 1512 then
							local rnum = math.random(1, 1000)
							if rnum == 1 then
								for b = -2, 2 do
								for c = -2, 2 do
								for d = -2, 2 do
									local vspot = a:index(x+b, y+c, z+d)
									local rnumb = math.random(1, 3)
									if rnumb == 1 and data[vspot] == c_etheral_stone then
										data[vspot] = c_etheral_stone_with_carbite
									end
								end
								end
								end
							end
						end
						if y <= 1850 and y >= 1512 then
							local rnum = math.random(1, 1000)
							if rnum == 1 then
								for b = -2, 2 do
								for c = -2, 2 do
								for d = -2, 2 do
									local vspot = a:index(x+b, y+c, z+d)
									local rnumb = math.random(1, 3)
									if rnumb == 1 and data[vspot] == c_etheral_stone then
										data[vspot] = c_etheral_stone_with_steelium
									end
								end
								end
								end
							end
						end
						--c_etheral_stone_with_steelium
					end

					if y <= -600 and y >= -610 then
							local vi = a:index(x, y, z)
							data[vi] = c_bedrock
					end
					--nether
					if  y <= -611 and y >= -800 then
							local vi = a:index(x, y, z)
							data[vi] = c_air
							if nethernvals[ni] - (y - 25) / 55 > 0.5 then
									local vi = a:index(x, y, z)
									local va = a:index(x, y-1, z)
									local vb = a:index(x, y-2, z)
									local vc = a:index(x, y-3, z)
									if y > -679 then
											data[vi] = c_nether_sand
											data[va] = c_nether_sand
											data[vb] = c_nether_sand
											data[vc] = c_nether_stone
									else
											data[vi] = c_obsidian
											data[va] = c_obsidian
											data[vb] = c_nether_stone
											data[vc] = c_nether_stone
									end
							elseif y < -680 then
									local vi = a:index(x, y, z)
									data[vi] = c_lava
							end
					end
					--nether ores
					if y <= -675 and y >= -800 then
						local rnum = math.random(1, 2000)--1 in 2000
						if rnum == 1 then
							for b = -2, 2 do
							for c = -2, 2 do
							for d = -2, 2 do
								local vspot = a:index(x+b, y+c, z+d)
								local rnumb = math.random(1, 3)
								if rnumb == 1 then
									if data[vspot] == c_nether_stone then
										data[vspot] = c_nether_stone_with_dark_diamond
									end
								end
							end
							end
							end
						end
					end

					if y <= -801 and y >= -810 then
						local vi = a:index(x, y, z)
						data[vi] = c_bedrock
					end
					--miner's dimention
					if y <= -811 and y >= -830 then
						local vi = a:index(x, y, z)
						data[vi] = c_air
					end
					if y <= -831 and y >= -850 then
						local vi = a:index(x, y, z)

						--rgen.set_randomseed(x*y*z)
						local name = rgen.get_random_data("Miner_l1")
						local cdat = minetest.get_content_id(name)
						data[vi] = cdat
					end
					if y <= -851 and y >= -880 then
						local vi = a:index(x, y, z)
						--rgen.set_randomseed(x*y*z)
						local name = rgen.get_random_data("Miner_l2")
						local cdat = minetest.get_content_id(name)
						data[vi] = cdat
					end

					if y <= -881 and y >= -890 then
						local vi = a:index(x, y, z)
						data[vi] = c_bedrock
					end

					--poison

					if y <= -891 and y >= -939 then
						local vi = a:index(x, y, z)
						data[vi] = c_air
					end


					if y <= -940 and y >= -941 then
						local vi = a:index(x, y, z)
						local vb = a:index(x, y-1, z)
						if y == -940 then
							if rgen.get_random_data("P_is_plant") == true then --get if the node should be a plant, 4 out of 7 chance
								local name = rgen.get_random_data("P_plants") --gets a random plant
								local cdat = minetest.get_content_id(name)
								data[vi] = cdat --sets the plant
								data[vb] = c_poison_grass --changes the node under the plant from poison liquid to poison dirt with grass
							else
								data[vi] = c_air --if not a plant, makes the node air
							end
						else
							data[vi] = c_poison_liquid --make the poison liquid base. this will change to dirt with grass if a plant spawns above
						end
					end

					if y <= -942 and y >= -944 then
						local vi = a:index(x, y, z)
						data[vi] = c_poison_dirt
					end

					if y <= -945 and y >= -980 then
						local vi = a:index(x, y, z)
						data[vi] = c_poison_stone

						--ore gen
						local rnum = math.random(1, 20000)--1 in 1000
						if rnum == 1 then
							for b = -2, 2 do
							for c = -2, 2 do
							for d = -2, 2 do
								local vspot = a:index(x+b, y+c, z+d)
								local rnumb = math.random(1, 3)
								if rnumb == 1 then
									data[vspot] = c_poison_stone_with_stratite
								end
							end
							end
							end
						end

					end

					if y <= -981 and y >= -990 then
						local vi = a:index(x, y, z)
						data[vi] = c_bedrock
					end
					--murite
					if y <= -991 and y >= -1200 then
						local vi = a:index(x, y, z)
							data[vi] = c_air
							if muritenvals[ni] - (y - 25) / 55 > 0.5 then
									local vi = a:index(x, y, z)
									local va = a:index(x, y-1, z)
									--local vb = a:index(x, y-2, z)
									--local vc = a:index(x, y-3, z)
									if y >= -1101 then
											data[vi] = c_murite_gravel
											if data[va] == c_murite_gravel then
											data[va] = c_murite_stone
											end
											--[[
											if data[vb] == c_grass then
											data[vb] = c_dirt
											end
											if data[vc] == c_dirt then
											data[vc] = c_stone
											end
											--]]
									else
											data[vi] = c_murite_stone
									end
							elseif y < -1100 then
									local vi = a:index(x, y, z)
									data[vi] = c_mercury
							end
					end

					if y <= -1000 and y >= -1210 then
						local vi = a:index(x, y, z)

						--ore gen
						local rnum = math.random(1, 20000)--1 in 1000
						if rnum == 1 then
							for b = -2, 2 do
							for c = -2, 2 do
							for d = -2, 2 do
								local vspot = a:index(x+b, y+c, z+d)
								local rnumb = math.random(1, 3)
								if rnumb == 1 then
								if data[vspot] == c_murite_stone then
									data[vspot] = c_murite_stone_with_crystal
								end
								end
							end
							end
							end
						end
					end

					if y <= -1201 and y >= -1210 then
						local vi = a:index(x, y, z)
						data[vi] = c_bedrock
					end

					--
                    ni = ni + 1
            end
            end
            end

            vm:set_data(data)

            vm:calc_lighting(
                    {x=minp.x-16, y=minp.y, z=minp.z-16},
                    {x=maxp.x+16, y=maxp.y, z=maxp.z+16}
            )
            vm:write_to_map(data)
    end)

